import java.io.*;
import java.util.Stack;
import java.util.Vector;

class TagChecker
{
	// e^OXgt@C
	final String tag_list_file = "checklist.txt";

	String text;					// `FbNׂeLXg
	private Vector list;			// Y^OXg
	private Vector check_tag_list;	// `FbN^OXg
	private Stack stack;			// ^O`FbNpX^bN

	// RXgN^
	public TagChecker(String text)
	{
		this.text = text;

		list = new Vector();
		check_tag_list = new Vector();
		stack = new Stack();

		// e^OXg̎擾
		try
		{
			// ̓Xg[̍쐬
			FileInputStream file_in = new FileInputStream(tag_list_file);
			BufferedReader reader = new BufferedReader(new InputStreamReader(file_in));

			// t@C̓ǂݍ
			String buffer;
			while((buffer = reader.readLine()) != null)
			{
				check_tag_list.add(buffer);
			}

			// Xg[
			reader.close();
			file_in.close();
		}
		catch(IOException ioe)
		{
			System.err.println(ioe);
		}
	}

	// ^O̕Y`FbN[`
	public UnclosedTagInfo[] analyze()
	{
		try
		{
			// ̓Xg[̍쐬
			StringReader string_reader = new StringReader(text);
			BufferedReader reader = new BufferedReader(string_reader);

			String buffer;
			int current_position = 0;	// n_(0)̍s̑Έʒu

			// sǂݍŉ͂
			while((buffer = reader.readLine()) != null)
			{
				analyzeOneLine(buffer,current_position);
				current_position += buffer.length() + 1;
			}

			// cĂY^O
			while(stack.empty() == false)
			{
				int position = text.length();
				String unclosed_tag = (String)stack.pop();

				list.addElement(new UnclosedTagInfo(position,unclosed_tag));
			}

			// Xg[
			reader.close();
			string_reader.close();
		}
		catch(IOException ioe)
		{
			System.err.println(ioe);
		}

		// r[փG[Xgԋp
		UnclosedTagInfo return_list[] = new UnclosedTagInfo[list.size()];
		list.copyInto(return_list);
		return(return_list);
	}

	// ^O̕Y`FbN[`(s)
	protected void analyzeOneLine(String line,int current_position)
	{
		int leftIndex = 0,rightIndex,spaceIndex;

		// '<'ꍇ
		while((leftIndex = line.indexOf('<',leftIndex)) != -1)
		{
			// '>'ꍇ
			if((rightIndex = line.indexOf('>',leftIndex + 1)) != -1)
			{
				// ^O̖O̎擾(ꍇ͖)
				String tag;
				if((spaceIndex = line.substring(leftIndex + 1,rightIndex).indexOf(' ')) != -1)
				{
					tag = line.substring(leftIndex + 1,leftIndex + spaceIndex + 1);
				}
				else
				{
					tag = line.substring(leftIndex + 1,rightIndex);
				}

				// '/'擪ɂꍇ
				if(!stack.empty() && tag.charAt(0) == '/')
				{
					// e^OXgɂ
					if(check_tag_list.contains(tag.substring(1,tag.length())))
					{
						// YꂪȂ܂ŁAYꃊXgɒǉ
						while(!stack.empty() && tag.substring(1,tag.length()).compareToIgnoreCase((String)stack.peek()) != 0)
						{
							int position = current_position + leftIndex;
							String unclosed_tag = (String)stack.pop();

							list.addElement(new UnclosedTagInfo(position,unclosed_tag));
						}

						// v^OX^bN菜
						// X^bN -> ^Ôݑ݂P[X
						if(!stack.empty())
						{
							stack.pop();
						}
					}
				}
				// PȂ^ȌꍇAX^bNɃvbV
				else
				{
					for(int i=0;i<check_tag_list.size();i++)
					{
						// e^OXgɂ
						if(check_tag_list.contains(tag.toLowerCase()))
						{
							stack.push(tag.toLowerCase());
							break;
						}
					}
				}

				// ^O̎͊̕Jn
				leftIndex = rightIndex + 1;
			}
			else
			{
				break;
			}
		}
	}
}